/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_COMMON_Common_Defines_PROXY_HPP_
#define V1_COMMONAPI_TELUX_COMMON_Common_Defines_PROXY_HPP_

#include <v1/commonapi/telux/common/CommonDefinesProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif


#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace common {

template <typename ... _AttributeExtensions>
class CommonDefinesProxy
    : virtual public CommonDefines,
      virtual public CommonDefinesProxyBase,
      virtual public _AttributeExtensions... {
public:
    CommonDefinesProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~CommonDefinesProxy();

    typedef CommonDefines InterfaceType;


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

    virtual std::future<void> getCompletionFuture();




 private:
    std::shared_ptr< CommonDefinesProxyBase> delegate_;
};

typedef CommonDefinesProxy<> CommonDefinesProxyDefault;


//
// CommonDefinesProxy Implementation
//
template <typename ... _AttributeExtensions>
CommonDefinesProxy<_AttributeExtensions...>::CommonDefinesProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast< CommonDefinesProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast< CommonDefinesProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
CommonDefinesProxy<_AttributeExtensions...>::~CommonDefinesProxy() {
}


template <typename ... _AttributeExtensions>
const CommonAPI::Address &CommonDefinesProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool CommonDefinesProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool CommonDefinesProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& CommonDefinesProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& CommonDefinesProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


template <typename ... _AttributeExtensions>
std::future<void> CommonDefinesProxy<_AttributeExtensions...>::getCompletionFuture() {
    return delegate_->getCompletionFuture();
}

} // namespace common
} // namespace telux
} // namespace commonapi
} // namespace v1



// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_COMMON_Common_Defines_PROXY_HPP_
